local SharedMedia = LibStub("LibSharedMedia-3.0");

--[[ Create a frame to use as the panel ]] -- 
panel = CreateFrame("FRAME", "Jarspeedo_Config");

panel:RegisterEvent("VARIABLES_LOADED");
panel:SetScript("OnEvent", function(self, event, ...)
    if event == "VARIABLES_LOADED" then
        self:VARIABLES_LOADED()
    end
end)

function panel:VARIABLES_LOADED()

    panel.bgButton = CreateColorPickerframe(panel, 5, -15, "Background Color: ")

    if Splits_Configs["BgColor"] then
        panel.bgButton.bg:SetColorTexture(Splits_Configs["BgColor"].r, Splits_Configs["BgColor"].g, Splits_Configs["BgColor"].b, Splits_Configs["BgColor"].a)
    else
        panel.bgButton.bg:SetColorTexture(0.18,0.2,0.16,0.35)
    end

    panel.bgButton:SetScript("OnMouseDown", function(self)
        local r,g,b,a = 0.18,0.2,0.16,0.35
        
        if Splits_Configs["BgColor"] then
            local colorConfigs = Splits_Configs["BgColor"];
            r,g,b,a = colorConfigs.r, colorConfigs.g, colorConfigs.b, colorConfigs.a
        end
        ShowColorPicker(r,g,b,a, BackgroundColorPickCallback);
    end)

    --completed requirement color selector
    panel.completedRequirementsColorButton = CreateColorPickerframe(panel, 5, -100, "Completed Requirements Color: ")

    if Splits_Configs["CompletedRequirementsColor"] then
        panel.completedRequirementsColorButton.bg:SetColorTexture(Splits_Configs["CompletedRequirementsColor"].r, Splits_Configs["CompletedRequirementsColor"].g, Splits_Configs["CompletedRequirementsColor"].b, Splits_Configs["CompletedRequirementsColor"].a)
    else
        panel.completedRequirementsColorButton.bg:SetColorTexture(MapColorToColorObject("green"))
    end

    panel.completedRequirementsColorButton:SetScript("OnMouseDown", function(self)
        local r,g,b,a = MapColorToColorObject("green")
        
        if Splits_Configs["CompletedRequirementsColor"] then
            local colorConfigs = Splits_Configs["CompletedRequirementsColor"];
            r,g,b,a = colorConfigs.r, colorConfigs.g, colorConfigs.b, colorConfigs.a
        end
        ShowColorPicker(r,g,b,a, CompletedRequirementsColorPickCallback);
    end)

    --partial requirement color selector
    panel.partialRequirementsColorButton = CreateColorPickerframe(panel, 5, -140, "In Progress Requirements Color: ")

    if Splits_Configs["PartialRequirementsColor"] then
        panel.partialRequirementsColorButton.bg:SetColorTexture(Splits_Configs["PartialRequirementsColor"].r, Splits_Configs["PartialRequirementsColor"].g, Splits_Configs["PartialRequirementsColor"].b, Splits_Configs["PartialRequirementsColor"].a)
    else
        panel.partialRequirementsColorButton.bg:SetColorTexture(MapColorToColorObject("yellow"))
    end

    panel.partialRequirementsColorButton:SetScript("OnMouseDown", function(self)
        local r,g,b,a = MapColorToColorObject("yellow")
        
        if Splits_Configs["PartialRequirementsColor"] then
            local colorConfigs = Splits_Configs["PartialRequirementsColor"];
            r,g,b,a = colorConfigs.r, colorConfigs.g, colorConfigs.b, colorConfigs.a
        end
        ShowColorPicker(r,g,b,a, PartialRequirementsColorPickCallback);
    end)

    --pending requirement color selector
    panel.pendingRequirementsColorButton = CreateColorPickerframe(panel, 5, -180, "Pending Requirements Color: ")

    if Splits_Configs["PendingRequirementsColor"] then
        panel.pendingRequirementsColorButton.bg:SetColorTexture(Splits_Configs["PendingRequirementsColor"].r, Splits_Configs["PendingRequirementsColor"].g, Splits_Configs["PendingRequirementsColor"].b, Splits_Configs["PendingRequirementsColor"].a)
    else
        panel.pendingRequirementsColorButton.bg:SetColorTexture(MapColorToColorObject("red"))
    end

    panel.pendingRequirementsColorButton:SetScript("OnMouseDown", function(self)
        local r,g,b,a = MapColorToColorObject("red")
        
        if Splits_Configs["PendingRequirementsColor"] then
            local colorConfigs = Splits_Configs["PendingRequirementsColor"];
            r,g,b,a = colorConfigs.r, colorConfigs.g, colorConfigs.b, colorConfigs.a
        end
        ShowColorPicker(r,g,b,a, PendingRequirementsColorPickCallback);
    end)

    combatTimerOptionButton = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
    combatTimerOptionButton:SetChecked(Splits_Configs["ShowCombatTimer"])

    combatTimerOptionButton.text = combatTimerOptionButton:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    combatTimerOptionButton.text:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -220)
    combatTimerOptionButton.text:SetFont("Fonts\\ARIALN.ttf", 15)
    combatTimerOptionButton.text:SetTextColor(1,1,1,1)
    combatTimerOptionButton.text:SetText("Show Time Spent in Combat")

    combatTimerOptionButton:SetPoint("LEFT", combatTimerOptionButton.text, "RIGHT")
    combatTimerOptionButton:SetScript("OnClick", 
    function()
        Splits_Configs["ShowCombatTimer"] = not Splits_Configs["ShowCombatTimer"]
        LoadComponents()
    end);



    deathCountOptionButton = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
    deathCountOptionButton:SetChecked(Splits_Configs["ShowDeathCount"])

    deathCountOptionButton.text = deathCountOptionButton:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    deathCountOptionButton.text:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -260)
    deathCountOptionButton.text:SetFont("Fonts\\ARIALN.ttf", 15)
    deathCountOptionButton.text:SetTextColor(1,1,1,1)
    deathCountOptionButton.text:SetText("Show Death Count")

    deathCountOptionButton:SetPoint("LEFT", deathCountOptionButton.text, "RIGHT")
    deathCountOptionButton:SetScript("OnClick", 
    function()
        Splits_Configs["ShowDeathCount"] = not Splits_Configs["ShowDeathCount"]
        LoadComponents()
    end);

    personalBestsOptionButton = CreateFrame("CheckButton", nil, panel, "ChatConfigCheckButtonTemplate");
    personalBestsOptionButton:SetChecked(Splits_Configs["ShowTimesToBeat"])

    personalBestsOptionButton.text = personalBestsOptionButton:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    personalBestsOptionButton.text:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -300)
    personalBestsOptionButton.text:SetFont("Fonts\\ARIALN.ttf", 15)
    personalBestsOptionButton.text:SetTextColor(1,1,1,1)
    personalBestsOptionButton.text:SetText("Show Personal Bests")

    personalBestsOptionButton:SetPoint("LEFT", personalBestsOptionButton.text, "RIGHT")
    personalBestsOptionButton:SetScript("OnClick", 
    function()
        Splits_Configs["ShowTimesToBeat"] = not Splits_Configs["ShowTimesToBeat"]
        RefreshUI()
    end);


    local fontSizeSlider = CreateBasicSlider(panel, "jarspeedoFontSizeSlider", "Font Size", 1, 100, 1)
    fontSizeSlider:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -340)
    fontSizeSlider:SetHeight(20)
    fontSizeSlider:SetWidth(100)
    fontSizeSlider:SetOrientation("HORIZONTAL")

    if Splits_Configs["DefaultFontSize"] then
        fontSizeSlider:SetValue(Splits_Configs["DefaultFontSize"])
        fontSizeSlider.valueText:SetText(Splits_Configs["DefaultFontSize"])
    else
        fontSizeSlider:SetValue(15)
        fontSizeSlider.valueText:SetText(15)
    end

    fontSizeSlider:SetScript("OnValueChanged", function(self, value)
        self.valueText:SetText(floor(value))
        UpdateDefaultFontSize(floor(value))
    end)



    -- Create the dropdown, and configure its appearance
    local dropDown = CreateFrame("FRAME", "JarspeedoDropdown", panel, "UIDropDownMenuTemplate")
    dropDown.text = dropDown:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    dropDown.text:SetPoint("TOPLEFT", panel, "TOPLEFT", 5, -45)
    dropDown.text:SetFont("Fonts\\ARIALN.ttf", 15)
    dropDown.text:SetTextColor(1,1,1,1)
    dropDown.text:SetText("Font:")
    dropDown:SetPoint("LEFT", dropDown.text, "RIGHT")

    if Splits_Configs["MainFont"] then
        UIDropDownMenu_SetText(dropDown, Splits_Configs["MainFont"])
    else
        UIDropDownMenu_SetText(dropDown, "Fonts\\ARIALN.ttf")
    end

    UIDropDownMenu_SetWidth(dropDown, 200)
 
    -- Create and bind the initialization function to the dropdown menu
    UIDropDownMenu_Initialize(dropDown, function(self, level, menuList)
        local info = UIDropDownMenu_CreateInfo()
    
        -- Display the 0-9, 10-19, ... groups
        for _,v in pairs(SharedMedia:HashTable("font")) do
            info.text, info.checked = v, false

            info.func = function (newValue)
                UIDropDownMenu_SetSelectedValue(dropDown, newValue.value, newValue.value)
                UIDropDownMenu_SetText(dropDown, newValue.value)
                newValue.checked = true
                UpdateMainFont(newValue.value)
            end

            UIDropDownMenu_AddButton(info)
        end
    end)
 
    function dropDown:SetValue(newValue)
        -- Update the text; if we merely wanted it to display newValue, we would not need to do this
        UIDropDownMenu_SetText(dropDown, newValue)
        -- Because this is called from a sub-menu, only that menu level is closed by default.
        -- Close the entire menu with this next call
        CloseDropDownMenus()
    end
end

function CreateBasicSlider(parent, name, title, minVal, maxVal, valStep)
    local slider = CreateFrame("Slider", name, parent, "OptionsSliderTemplate")
    slider:SetMinMaxValues(minVal, maxVal)
    --slider:SetValue(0)
    slider:SetValueStep(valStep)
    slider.text = _G[name.."Text"]
    slider.text:SetText(title)    
    slider.valueText = slider:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    slider.valueText:SetFont("Fonts\\ARIALN.ttf", 15)
    slider.valueText:SetPoint("CENTER", slider.text, "CENTER", 0, -15)
    slider.textLow = _G[name.."Low"]
    slider.textHigh = _G[name.."High"]
    slider.textLow:SetText(floor(minVal))
    slider.textHigh:SetText(floor(maxVal))
    slider.textLow:SetTextColor(0.4,0.4,0.4)
    slider.textHigh:SetTextColor(0.4,0.4,0.4)
    return slider
  end

function CreateColorPickerframe(parent, x, y, text)
    local frame = CreateFrame("Frame", nil, parent, BackdropTemplateMixin and "BackdropTemplate");

    frame.text = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    frame.text:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y)
    frame.text:SetFont("Fonts\\ARIALN.ttf", 15)
    frame.text:SetTextColor(1,1,1,1)
    frame.text:SetText(text)

    frame:SetPoint("LEFT", frame.text, "RIGHT", 0, 0);
    frame:SetSize(30,30);

    frame.bg = frame:CreateTexture(nil, "BACKGROUND")
    frame.bg:SetAllPoints(true)

    frame:SetBackdrop({
        bgFile = nil,
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        edgeSize = 4,
        insets = { left = 8, right = 8, top = 8, bottom = 8 },
    })
    return frame
end


function ShowColorPicker(r, g, b, a, changedCallback)
    ColorPickerFrame:SetColorRGB(r,g,b);
    --for some reason this is inverted
    ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), 1-a;
    ColorPickerFrame.previousValues = {r,g,b,a};
    ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = changedCallback, changedCallback, changedCallback;
    ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
    ColorPickerFrame:Show();
end



panel.name = "Jarspeedo";

-- [[ When the player clicks okay, set the original value to the current setting ]] --
panel.okay = 
    function (self)
        
	end
-- [[ When the player clicks cancel, set the current setting to the original value ]] --
panel.cancel =
	function (self)
		
	end
-- [[ Add the panel to the Interface Options ]] --
InterfaceOptions_AddCategory(panel);

