
SLASH_JARSPEEDOTEST1 = "/jarspeedo_tests";

local playerName = UnitName("player")
local currInstance = 548 --ssc

function SlashCmdList.JARSPEEDOTEST(message, editbox)
    SlashCmdList.JARSPEEDOSHOWSPLITS("ssc")
    RunTests()
end

function RunTests()
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
    RunSSCTestEncounterEngage()
    RunSSCTestEncounterKillNotComplete()
    RunSSCTestEncounterComplete_success()
    RunSSCTestEncounterComplete_failure()
    RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_ValidId_ValidStart()
    RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_ValidId_InvalidStart()
    RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_InvalidId_ValidStart()
    RunSSCTest_RequirementCompletion()
    RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_SPELLCAST_SUCCESS_ValidStartId()
    RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_SPELLCAST_SUCCESS_InvalidStartId()
    RunSSCTestsFull_success()
end

function RunSSCTestEncounterEngage()
    j_main_frame:ENCOUNTER_START(623, "Hydross the Unstable")
    local time = time()

    print("RunSSCTestEncounterEngage", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 0 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"][4].startTime == time)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTestEncounterKillNotComplete()
    j_main_frame:ENCOUNTER_START(623, "Hydross the Unstable")
    local time = time()
    HandleUnitDeath(time, 21216)


    print("RunSSCTestEncounterKillNotComplete", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 1 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"][4] == nil)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTestEncounterComplete_success()
    j_main_frame:ENCOUNTER_START(623, "Hydross the Unstable")
    j_main_frame:ENCOUNTER_END(623, "Hydross the Unstable", nil, nil, 1)
    local time = time()
    
    print("RunSSCTestEncounterComplete_success", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 1 
        and Splits_Configs[playerName][currInstance]["CompletedRequirements"][4].startTime == time
        and Splits_Configs[playerName][currInstance]["CompletedRequirements"][4].timestamp == time
        and Splits_Configs[playerName][currInstance]["CompletedRequirements"][4].requirementId == 4)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTestEncounterComplete_failure()
    j_main_frame:ENCOUNTER_START(623, "Hydross the Unstable")
    j_main_frame:ENCOUNTER_END(623, "Hydross the Unstable", nil, nil, 0)

    local time = time()

    print("RunSSCTestEncounterComplete_failure", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 0 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"][4].startTime == time)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_ValidId_ValidStart()
    local time = time()
    HandleSpellCastSuccess(time, 21301)
    HandleUnitDeath(time, 21301)


    print("RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_ValidId_ValidStart", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 0 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"][3].startTime == time)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTest_RequirementCompletion()
    local time = time()
    HandleSpellCastSuccess(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)
    HandleUnitDeath(time, 21301)

    print("RunSSCTest_RequirementCompletion", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 1 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"][3] == nil)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_ValidId_InvalidStart()
    local time = time()
    HandleUnitDeath(time, 21301)

    print("RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_ValidId_InvalidStart", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] ~= true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 0 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"] == nil)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_InvalidId_ValidStart()
    local time = time()    

    HandleSpellCastSuccess(time, 21301)
    HandleUnitDeath(time, 21301)
    
    print("RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_UNIT_DIED_InvalidId_ValidStart", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 0 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"][3].startTime == time)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_SPELLCAST_SUCCESS_ValidStartId()
    local time = time()
    HandleSpellCastSuccess(time, 21301)
    
    print("RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_SPELLCAST_SUCCESS_ValidStartId", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] == true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 0 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"][3].startTime == time)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_SPELLCAST_SUCCESS_InvalidStartId()
    local time = time()
    HandleSpellCastSuccess(time, "Jarbito")
    
    print("RunSSCTest_COMBAT_LOG_EVENT_UNFILTERED_SPELLCAST_SUCCESS_InvalidStartId", 
    Splits_Configs[playerName][currInstance]["RunInProgress"] ~= true 
        and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 0 
        and Splits_Configs[playerName][currInstance]["PartialRequirements"] == nil)
        
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
    SlashCmdList.JARSPEEDOSHOWSPLITS("reset ssc")
end

function RunSSCTestsFull_success()
    
    j_main_frame:ENCOUNTER_START(623, "Hydross the Unstable")
    j_main_frame:ENCOUNTER_END(623, "Hydross the Unstable", nil, nil, 1)
    j_main_frame:ENCOUNTER_START(624, "The Lurker Below")
    j_main_frame:ENCOUNTER_END(624, "The Lurker Below", nil, nil, 1)
    j_main_frame:ENCOUNTER_START(625, "Fathom-Lord Karathress")
    j_main_frame:ENCOUNTER_END(625, "Fathom-Lord Karathress", nil, nil, 1)
    j_main_frame:ENCOUNTER_START(626, "Leotheras the Blind")
    j_main_frame:ENCOUNTER_END(626, "Leotheras the Blind", nil, nil, 1)
    j_main_frame:ENCOUNTER_START(627, "Morogrim Tidewalker")
    j_main_frame:ENCOUNTER_END(627, "Morogrim Tidewalker", nil, nil, 1)
    j_main_frame:ENCOUNTER_START(628, "Lady Vashj")
    j_main_frame:ENCOUNTER_END(628, "Lady Vashj", nil, nil, 1)

    HandleSpellCastSuccess(time(), 21224)
    for k = 1,20 do 
        HandleUnitDeath(time(), 21224)
    end

    HandleSpellCastSuccess(time(), 21251)
    for k = 1,6 do 
        HandleUnitDeath(time(), 21251)
    end

    HandleSpellCastSuccess(time(), 21301)
    for k = 1,14 do 
        HandleUnitDeath(time(), 21301)
    end

    HandleSpellCastSuccess(time(), 21229)
    for k = 1,16 do   
        HandleUnitDeath(time(), 21229)
    end

    HandleSpellCastSuccess(time(), 21299)
    for k = 1,6 do 
        HandleUnitDeath(time(), 21299)
    end

    HandleSpellCastSuccess(time(), 21218)
    for k = 1,6 do 
        HandleUnitDeath(time(), 21218)
    end

    print("RunSSCTestsFull_success", Splits_Configs[playerName][currInstance]["RunInProgress"] ~= true and Splits_Configs[playerName][currInstance]["CompletedRequirementsCount"] == 12)
        
    --SlashCmdList.JARSPEEDOSHOWSPLITS("resetpbs ssc")
    SlashCmdList.JARSPEEDOSHOWSPLITS("resetpbs ssc")
end